/*
 * $Id: toolbar.prg 649 2011-06-24 16:53:20Z concentra $
 */

/*
 * HMG Source Code
 *
 * Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 * http://sites.google.com/site/hmgweb/
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or( at your option ) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License FOR more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this software; see the file COPYING. IF not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA( or
 * visit the web site http://www.gnu.org/ ).
 *
 * As a special exception, you have permission FOR additional uses of the text
 * contained in this release of HMG.
 *
 * The exception is that, IF you link the HMG library with other
 * files to produce an executable, this does not by itself cause the resulting
 * executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of linking the
 * HMG library code into it.
 */

#include "hbclass.ch"
#include "common.ch"

/*----------------------------------------------------------------------*/

CLASS TOOLBAR FROM CONTROL

   // Internal Data
   DATA cClass                                    INIT   "TOOLBAR"
   DATA cType                                     INIT   'ToolBar'
   DATA nButtonWidth                              INIT   NIL
   DATA nButtonHeight                             INIT   NIL
   DATA lStrictWidth                              INIT   NIL
   DATA lBottom                                   INIT   .F.
   DATA lRightText                                INIT   .F.
   DATA lBorder                                   INIT   .F.
   DATA lBreak                                    INIT   .F.
   DATA aButtons                                  INIT   {}

   // Properties
   METHOD ButtonWidth                             SETGET
   METHOD ButtonHeight                            SETGET
   METHOD StrictWidth                             SETGET
   METHOD Bottom                                  SETGET
   METHOD RightText                               SETGET
   METHOD Border                                  SETGET
   METHOD Break                                   SETGET

   // Methods
   METHOD New

ENDCLASS

/*----------------------------------------------------------------------*/

METHOD ButtonWidth( nValue ) CLASS TOOLBAR

   IF Pcount() == 0
      RETURN ::nButtonWidth
   ELSEIF Pcount() == 1
      ::nButtonWidth := nValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Break( lValue ) CLASS TOOLBAR

   IF Pcount() == 0
      RETURN ::lBreak
   ELSEIF Pcount() == 1
      ::lBreak := lValue
      IF ::lBreak
         ::oParent:oQTObject:insertToolBarBreak( ::oQTObject )
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD ButtonHeight( nValue ) CLASS TOOLBAR

   IF Pcount() == 0
      RETURN ::nButtonHeight
   ELSEIF Pcount() == 1
      ::nButtonHeight := nValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD StrictWidth( lValue ) CLASS TOOLBAR

   IF Pcount() == 0
      RETURN ::lStrictWidth
   ELSEIF Pcount() == 1
      ::lStrictWidth := lValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Bottom( lValue ) CLASS TOOLBAR

   IF Pcount() == 0
      RETURN ::lBottom
   ELSEIF Pcount() == 1
      ::lBottom := lValue
      IF ::lBottom
         ::oParent:oQTObject:addToolBar( 8 , ::oQTObject )
      ELSE
         ::oParent:oQTObject:addToolBar( ::oQTObject )
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD RightText( lValue ) CLASS TOOLBAR

   IF Pcount() == 0
      RETURN ::lRightText
   ELSEIF Pcount() == 1
      ::lRightText := lValue
      IF ::lRightText
         ::oQTObject:SetToolButtonStyle( 2 )
      ELSE
         ::oQTObject:SetToolButtonStyle( 3 )
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Border( lValue ) CLASS TOOLBAR

   IF Pcount() == 0
      RETURN ::lBorder
   ELSEIF Pcount() == 1
      ::lBorder := lValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/
//                               Methods
/*----------------------------------------------------------------------*/

METHOD New( cName, oParent ) CLASS TOOLBAR

   Super:New( cName, oParent )

   //  Create QT Object
   ::oQTObject := QToolBar()
   ::oQTObject:SetToolButtonStyle( 3 )

   IF ::oParent:cClass == "WINDOW"
      ::oParent:oQtWindowObject:addToolBar( ::oQTObject )
   ELSE
      ::oParent:oQTObject:addToolBar( ::oQTObject )
   ENDIF

   RETURN Self

/*----------------------------------------------------------------------*/
